/*
One of those Weeks Day 6
Copyright (c) 2008-2009 Blazing Games Inc.
Code written by Billy D. Spelchan

This program is free software; you can redistribute it and/or modify it under 
the terms of the GNU General Public License as published by the Free Software 
Foundation; either version 2 of the License, or (at your option) any later 
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with
this program; if not, write to the Free Software Foundation, Inc.,
59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
package com.blazinggames.ootw.converse
{
	// Adobe Imports
	import flash.display.SimpleButton;
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import flash.text.TextField;
	
	
	/**
	 * The dialog window that is used for cartoon style dialog sequences. The
	 * movie clip that implements this class should have 12 labels for the 6 
	 * different dialog state named:
	 * description and descriptionDone
	 * speach and speachDone
	 * thought and thoughtDone
	 * exclamation and exclamationDone
	 * whisper and whisperDone
	 * robotic and roboticDone
	 *
	 * the class should also have a text area for the text that is named
	 * _message_txt
	 *
	 * @author Billy D. Spelchan
	 * @version 1.0
	 * Copyright (c) 2007 Blazing Games Inc. All Rights Reserved.
	*/
	public class CartoonResponse
	extends MovieClip
	implements IResponse
	{
// *********************
// ***** CONSTANTS *****
// *********************

		protected static const DONESTRING:String = "Done";

// *********************
// ***** VARIABLES *****
// *********************

		public var messageText:String = " ";
		public var showQuickly:Boolean;
		public var resultCode:int;

		protected var _animatedText:AnimatedText
		// note that all _*_movie, _*_btn and _*_txt variables are in movie

// ***********************
// ***** CONSTRUCTOR *****
// ***********************

		public function CartoonResponse()
		{
			showQuickly = false;
			_animatedText = new AnimatedText();
		}

// ******************************************
// ***** Functions - IResponse required *****
// ******************************************

		public function showResponse(s:String, rCode:int,
				quickly:Boolean=false, dtype:int=0):void
		{
//			trace("Cartoon Response should be Showing");
			resultCode = rCode;
			var label:String = Converse.DIALOG_LABELS[dtype];
			if (quickly)
				label += DONESTRING;
			visible = true;
			messageText = s;
			_message_txt.text = " ";
			gotoAndPlay(label);
		}

		public function hideResponse():void
		{
			visible = false;
		}

		public function isShowing():Boolean
		{
			return visible;
		}

		public function getResultCode():int
		{
			return resultCode;
		}

// **************************************
// ***** Functions - Event handlers *****
// **************************************

		protected function finishedShowing()
		{
			stop();
			var evnt:Event = new Event(Converse.RESPONSE_SHOWN_EVENT);
			this.dispatchEvent(evnt);
			_animatedText.setText(_message_txt, messageText, 1, 24);
		}

// ***************************************
// ***** Functions - General control *****
// ***************************************

	} // end class
} // end package

